'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUM C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

'-----------------------------------------------------------------------
' THEMA: DIGITALPORTS ALS SERIELLE SCHNITTSTELLE mit MICRO-MODUL
'        PRINT
'        GOSUB
'-----------------------------------------------------------------------
' Beispiel zur C-Control MICRO mit dem Programmer/Application-Board (P/A-BOARD)
' Die C-Control MICRO hat sechs Ports die, auch innerhalb eines Programms,
' verschiedene Funktionen erfllen. Der Port 1 kann als TXD einer seriellen
' Schnittstelle dienen.
' Sie brauchen also nur ein Terminalprogramm auf dem PC zu starten, um die Ausgaben
' der C-Control zu lesen.
' Um die Schnittstelle zu aktivieren muss zuerst die Baudrate definiert werden.
' BAUD 9600 oder BAUD 19200 (andere Baudraten weden nicht bercksichtigt)
' Damit wird der PORT gleichzeitig als OUTPUT geschaltet
' Die Schnittstellenfunktion schalten Sie mit DEACT ab.
'-------------------------------------------------------------------------
' Verebinden Sie Port 4 der MICRO (Patchfeld) mit Port 8 am Unit-Bus.
' Bettigen Sie die Taste F2 auf der Tastatur des Application-Board.
' JP3 am MICRO-Modul muss dazu nach rechts gesteckt sein. 
'-------------------------------------------------------------------------
' Achtung !
' Wenn sie das MICRO-Modul bei empfangsbereiten Terminalprogramm einschalten,
' werden einige "wirre" Zeichen angezeigt, da sich die Betriebsspannung
' erst stabilisieren muss und der Pegel am seriellen Eingang des PC nicht
' definiert ist
'------------------------------------------------------------------------


'--------------------------
'------ I/O PORTS ---------
'--------------------------
define TASTER   port[4]
define TXD      port[1]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define COUNTS   byte[1]


BAUD 9600:pause 10
'--------------------------------------------------
'          USING PORT1 AS SERIAL OUTPUT           -
'--------------------------------------------------
print "WIR ZAEHLEN TASTENDRUCKE"
PRINT "- BITTE TASTER DRUECKEN -"
#WAIT
if TASTER=on then gosub COUNT
goto WAIT

#COUNT
COUNTS=COUNTS+1:print COUNTS
#WAIT_RELEASE
if TASTER=on then goto WAIT_RELEASE
return

