'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUM C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'
'----------------------------------------------------------------------
' TOOL ZUR CALIBRIERUNG DER ECHTZEIT UHR (RTC)
'----------------------------------------------------------------------
' Die C-CONTROL MICRO wird von einem frei laufenden Oszillator gespeist,
' der Ansprche fr eine genaue Baudrate prinzipiell nicht erfllen kann.
' Der Hersteller gibt eine Grundgenauigkeit von 25 % an.
' Eine automatische Calibrierung der Baudrate bei jedem Download eines BASIC-Programms stellt
' zwar den Betireb bei 9600 Baud sicher, ist u.U. aber nicht ausreichend fr den
' Betrieb mit 19200 Baud (vor allem wenn der RC-Oszillator driftet, oder die
' Betriebsspannung schwankt).
' Um trotzdem den Betrieb bei 19200 Baud zu ermglichen, kann der Oszillator calibriert
' werden.
'-------------------------------------------------------------------------
' Der Befehl FREQ2=WERT schreibt einen Korrekturfaktor in das Betriebssystem,
' der den Takt um 0,2% je Digit (ausgehend vom Defaultwert 128, nach dem RESET)
' korrigiert.
' Der Inhalt von FREQ2 kann nicht gelesen werden und eine Anweisung wie etwa
' a=FREQ2 fhrt zu unkontrollierbarem Fehlverhalten, da das entsprechende TOKEN
' vom INTERPRETER der MICRO nicht erkannt wird.
'-------------------------------------------------------------------------
' Dieses Programm erhht/verringert den Wert in FREQ2 bei jedem kurzen/langen Tastendruck,
' ausgehend vom default Wert 128 = &H80.
' kurz= 0....200ms, lang= 0....1s
' Ein Tastendruck darf auf keinen Fall lnger als eine Sekunde sein, da der Timer ber
' Null rollt und ein kurzer Druck gemessen wird.
' Nach jedem neuen Wert fr FREQ2 wird dieser und ein Kontrollstring ausgegeben.
' Mit einem Terminalprogramm knnen Sie den Bereich der gltigen Werte ermitteln.
' Der gesuchte Wert liegt in der Regel nicht weit von der Defaulteinstellung.
' Nhern Sie sich deshalb in kleinen Schritten um auch zu ermitteln, ob FREQ2
' grsser oder kleiner werden muss.
' z.B.   Einschalten, Schritte nach unten  
'
' Whlen sie fr die Korrektur des Oszillators
'
' FREQ2=KORREKTUR
'
' einen Wert aus der Mitte dieses Bereiches.
' Verwenden Sie diesen Wert einmalig in der Initialisierung Ihres Anwenderprogramms.
'
' ACHTUNG:
' Wenn Sie die Anleitung aufmerksam gelesen haben, wissen Sie, dass das P/E-Board wegen
' grosser Zeitkonstanten nicht 19200 Baud fhig ist.
' Sie knnen diese Kalibrierung erfolgreich auf dem P/E-Board durchfhren, weil damit
' auch die Zeitkonstanten "herauscalibriert" werden, jedoch ist der gefundene KORREKTURWERT
' nicht reprsentativ, wenn die MICRO in Ihrer Anwendung spter einen anderen
' RS232 Pegelwandler benutzt.
'------------------------------------------------------------------------------------
' ----> Sie knnen das P/E-Board auf diese Weise 19200 Baud fhig machen
' ----> Wenn Ihre MICRO nach der Programmierung in einer anderen Hardwareumgebung
'       bez. RS 232 luft, muss sie auch in dieser calibriert werden.
'------------------------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define LED      port[5]
define TASTER   port[3]
define TXD      port[1]
define BEEPPORT port[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define COUNTS   byte[1]

BAUD 19200
freq2=&H80:COUNTS=&H80
'--------------------------------------------------
'       LOOKING FOR GOOD FREQ2 VALUES             -
'--------------------------------------------------
print "CALIBRIERUNG DES OSZILLATORS"
PRINT "- BITTE TASTER DRUECKEN -"
#WAIT
WAIT not TASTER:SECOND=0:
WAIT TASTER
if TIMER < 10 then goto INCREASE

#DECREASE
COUNTS=COUNTS-5:FREQ2=COUNTS:pause 5:print COUNTS;:print " TESTCHARACTERS"
goto WAIT

#INCREASE
COUNTS=COUNTS+5:FREQ2=COUNTS:pause 5:print COUNTS;:print " TESTCHARACTERS"
goto WAIT

