'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII  DEMO ZUM BASIC-COMPUTER MICRO         (by DIE HARD)   IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER MICRO mit dem Programmer/Application-Board
'--------------------------------------------------------------------
' ANWENDUNG: Kommunikation UNIT M 2.0 <--> UNIT MICRO ber den IIC-Bus
'            mit einer MICRO als Slave      -Beispiel 2-
'            Programm fr den SALVE (UNIT MICRO)        - Beispiel 2 -
'---------------------------------------------------------------------
'
' Sie finden hier ein Beispiel zu eimem Treiber der die Unit MICRO zu
' einem IIC-BUS SLAVE macht. Sie knnen fast beliebig viele Slaves am IIC-Bus
' betreiben wenn es erforderlich ist.
' Details finden Sie im Beispiel 1.
'
' Funktion des Treibers:
' Im Prinzip werden immer zwei Variableninhalte ausgetauscht, also
' vom Master zum Slave oder umgekehrt.
' Die Variablen knnen gewhlt werden (BYTEVARIABLE 1 bis 24)

' Anwendungen:
' Im Prinzip kann man mit diesem Protokoll, wie Sie es im Beispiel 1
' kennen gelern haben alles machen.
'
' <ADRESSE><MEMLOC><MEM_CONTENT><MEM+1_CONTENT>
'
' In diesem Beispiel nehmen wir an, der Slave ist ein "Steuer u. Regelslave.
' Der Slave hat das Interface zur Sensorik (hier AD6)und Regelung (hier DA1)
' der MASTER entscheidet wie die Regelung zu erfolgen hat.
' In diesem Beispiel wird der Wert von SLAVE-AD6 einfach vom Master gelesen und
' unbearbeitet an den DA1 des SLAVE zurck geschickt.
' Der MASTER veranlasst den SLAVE die LED4 Zu aktivieren, wenn der Wert von AD6
' grsser 200 ist.Der Master erzeugt bei jeder Sendung einen kurzen Klick am Beeper.
' Beachten Sie unbedingt,dass der SLAVE nach einem empfangenen Datenrahmen
' etwas Zeit zur Ausfhrung von Kommandos etc. braucht. 
' Wir entscheiden uns fr einen Datenaustausch folgender Art
'
'  SLAVE VARIABLEN
' ---- Vom Master gelesen -----
'  BYTE 5  SENSORWERT von AD6      (muss vom Slave also stndig aktualisiert werden)
'  BYTE 6  ALLGEMEINER STATUS      (z.B. Besttigung wenn Kommando ausgefhrt wurde)
'----- vom Master beschrieben--
'  BYTE 7  REGELWERT fr DA1       (DA1 muss also auch stndig aktualisiert werden)
'  BYTE 8  ALLGEMEINE DATEN        (ein fiktiver Wert in diesem Beispiel)
'----- vom MASTER beschrieben--
'  BYTE 9  KOMMANDO                (eines von 255 mglichen Kommandos fr den SLAVE)
'  BYTE 10 PARAMETER               (ein mglicher Wert als Ergnzung zum Kommando z.B
'                                   BEEP und Tonhhe oder Portausgabe und Wert
'-----------------------------------------------------------------------------------
' Wenn das Programm luft, knnen Sie verschiedene Sensor-Werte erzeugen, indem
' sie das POTI P/E-Board der MICRO drehen. Achten Sie darauf dass die Jumper richtig
' gesetzt sind:
'----------------------------------------------------------------------------------
' Stecken Sie bitte die Jumper JP2 und JP1 (auf Position 1-2)damit die Demo korrekt
' funktioniert.
'-----------------------------------------------------------------------------------

'
' Anmerkung
' Das Programm gibt natrlich nicht wirklich Sinn. Sie sehen aber deutlich wie
' Daten zwischen SLAVE und MASTER ausgetauscht werden, und wie man damit Aktionen
' Auslsen kann-
' Das Treiberprogramm (auf PAGE0) reserviert fr die MICRO als SLAVE die
' PORTS 2 u.5 (PORT2=SDA PORT5=SCL)
'
' Ist der MASTER eine UNIT M 2.0, sollten Sie die standardmssigen IIC-BUS PORTS
' (Port9 u. 10) verwenden. Der Bus arbeitet dann mit maximaler Geschwindigkeit.
' In diesem Fall muss also der MASTER PORT9 (SDA) mit SLAVE PORT2 (SDA)
' und MASTER PORT10 (SCL) mit SLAVE PORT5 (SCL) verbunden werden.
' Sie drfen am MASTER (wenn er eine UNIT M 2.0 ist) das LCD nicht betreiben,
' weil sich das LCD seine Leitungen mit dem IIC-BUS teilt, und die MICRO
' als SLAVE nicht in der LAGE ist zu erkennen wenn Daten am IICBUS eigentlich
' dem LCD des MASTERS gelten.
' Beachten Sie das DELAY "DATA0=DATA0" bei der READ Operation. Es ist fr die
' MICRO notwendig.                  !!!!!!!!!
' print"#START#";:put ADDR+1:put 5:DATA0=DATA0:get DATA0:get DATA1:print"#STOP#";"#OFF#";
' Beschleunigen Sie die MICRO mit "FREQ2=0" wenn Sie bei der Datenbertragung auf Probleme
' stossen (normal nicht erforderlich)
'
' Sie knnen jedoch als Master natrlich auch eine UNIT M 2.0 oder eine andere
' MICRO mit einem BASIC-Treiber auf beliebigen Ports einsetzen. Als Master
' spielt die geringere Geschwindigkeit dann keine Rolle.
'------------------------------------------------------------------------------



'--------------------------
'------ I/O PORTS ---------
'--------------------------
define SLAVESDA     port[2]
define SLAVESCL     port[5]
define REGLER         da[1]
define SENSOR         ad[6]
define LED4         port[4]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
'--IIC BUS SLAVE DRIVER---
define ADDR        byte[1]
define MEMLOC      byte[2]
'---- USER PROGRAM -------
define FREI1       byte[3]
define FREI2       byte[4]
'-------------------------
define SENSOR_OUT   byte[5]
define STATUS_OUT   byte[6]
define REGLER_IN    byte[7]
define DATEN_IN     byte[8]
define COMMAND_IN   byte[9]
define PARAM_IN     byte[10]

define MEM1        byte[5]
define MEM2        byte[6]


define IICINIT &HFDA0
#INIT
ADDR=&H50

'FREQ2=0

'---------------------------------------------
'            SLAVE PROGRAMM
'---------------------------------------------
SYS IICINIT
#LOOP
MEMLOC=0
#LP
'-HIER AKTUALISIERT DER SLAVE DIE DATEN FR DEN ABRUF-
SENSOR_OUT=SENSOR:STATUS_OUT=0
'----- SOLANGE MEMLOC=0 WURDE NICHTS EMPFANGEN ------
if MEMLOC=0 then goto LP
'--------------------------------------------------
'---       AUSWERTUNG  EMPFANGENER DATEN         --
'--------------------------------------------------
' Bei einer READ Operation wurden nur Daten abgefragt
' es ist nichts zu tun ausser MEMLOC zu lschen
if (ADDR and 01)=1 then goto LOOP
'----------------------------------------------------
' Bei einer WRITE Operation muss unterschieden werden
' was getan werden muss

'- ABFRAGE OB AKTUELLE DATEN FR DEN REGLER VORLIEGEN-
if MEMLOC=7 then goto REGLERDATEN

'--------- ABFRAGE OB EIN KOMMANDO VORLAG -----------
if MEMLOC=9 then goto COMMAND

'- DIESE LISTE KNNTE NATRLICH AUCH KOMPLEXER SEIN --
goto LOOP
'----------------------------------------------------
'REGLER EINSTELLEN
'----------------------------------------------------
#REGLERDATEN
REGLER=REGLER_IN:goto LOOP '
'----------------------------------------------------
'KOMMANDO AUSWERTEN
'----------------------------------------------------'
'Der Kommandointerpreter kennt hier nur 2 Kommandos
'nmlich die LED an Port 4 ein oder aus zu schalten.
'Es knnte ein Parameter bermittelt werden, der aber
'dazu nicht erforderlich ist.

#COMMAND
on COMMAND_IN goto CMD0,CMD1
#CMD0
LED4=on:goto LOOP
#CMD1
LED4=off:goto LOOP





'---------------------------------------------
syscode "MICRO_IIC_SLAVE_PAGE0.s19"
