'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUM C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'
'-----------------------------------------------------------------------
' THEMA: TIMER
'        DIGITALPORTS ALS SERIELLE SCHNITTSTELLE
'-----------------------------------------------------------------------
' Beispiel zur C-Control MICRO mit dem Programmer/Application-Board (P/A-BOARD)
' Wir verwenden hier den Timer um die Reaktionszeit zu messen.
'
' Das Programm schaltet die LED ein und misst die Zeit bis zum Tastendruck.
' Die Ausgabe erfolgt auf ein Terminalprogramm.
' Beachten Sie bitte, dass der Timer zwar bis zu einem Zhlerstand von 50 geht
' (1 Sekunde) aber ab 13 bei der Umrechnung in ms 13*12=260 ein berlauf auftritt.
' Gemessen werden deshalb nur Zeiten bis 240ms, mit einer Auflsung von 20ms
' 
' SEC=x setzt den 20 ms Timer auf Null zurck.
'

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define LED      port[5]
define TASTER   port[3]
define TXD      port[1]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define COUNTS   byte[1]

'BAUD 19200
BAUD 9600:pause 1
'--------------------------------------------------
'          USING PORT1 AS SERIAL OUTPUT           -
'--------------------------------------------------
print "   - EIN REAKTIONSSPIEL - ":print" "
#LOOP
print "DRUECKEN SIE DIE TASTE SOBALD DIE LED LEUCHTET"
'--------------- WAIT 5 SECONDS -------------------
SECOND=0:wait SECOND=5
'----------- CLEAR TIMER and LED ON ---------------
LED=on:SECOND=0:
#WAIT_BUTTON
if TIMER >40 then goto TOO_LATE
if TASTER then goto WAIT_BUTTON
'---------- SAVE THE RESULT -----------------------
COUNTS=TIMER
'----------- 13*20ms=260 (more than a Byte) -------
if COUNTS>12 then goto TOO_LATE
'---------- PUT RESULT TO TERMINAL ----------------
print "TIME ELAPSED: ";:print COUNTS*20;:print " ms"
print:print:print:LED=off
'---------- WAIT FOR BUTTON RELEASED --------------
wait TASTER:goto LOOP


#TOO_LATE
print" < ZU LANGSAM >":LED=off:print:print:goto LOOP

