'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'-----------------------------------------------------------------------
' THEMA: FREQ2 - SYSTEM CLOCK CALIBRATION
'-----------------------------------------------------------------------
' Beispiel zur C-Control MICRO mit dem Programmer/Application-Board (P/A-BOARD)
' Die C-CONTROL MICRO hat einen freilaufenden RC Oszillator der hinsichtlich
' seiner Genauigkeit bestimmten Ansprchen (wie sie z.B. eine Uhr stellt)
' nicht gengt.
' Der Befehl
'
' FREQ2=Wert
'
' schreibt einen Korrekturfaktor in das Betriebssystem,
' der den Takt um 0,2% je Digit (ausgehend vom Defaultwert 128, nach dem RESET)
' korrigiert.
' Damit lsst sich der Takt auf 0,2% genau einstellen. Sehen Sie dazu auch
' die bereitgestellten Hilfsprogramme TOOL_CLOCK_CALIBRATE und TOOL_19200_CALIBRATE 
'
' Der Inhalt von FREQ2 kann nicht gelesen werden und Anweisungen wie etwa
'
' a=FREQ2
' FREQ2=FREQ2+1
'
' fhren zu unkontrollierbarem Fehlverhalten, da das entsprechende TOKEN
' vom INTERPRETER der MICRO nicht erkannt wird.
'--------------------------------------------------------------------------
' BEISPIEL:
' Das Beispiel erzeugt durch Toggeln des PORTS 6 einen TON und verstimmt
' den Oszillator gleichzeitig schrittweise.   
' Sie hren deutlich den Einfluss auf die Arbeitsgeschwindigkeit des Prozessors.
' Man kann damit auch nette Klangeffekte erzeugen, wie sie an den beiden Demos sehen.
'--------------------------------------------------------------------------
' Stecken Sie bitte die Jumper JP2 und JP1 (auf Position 1-2)damit die Demo korrekt
' funktioniert.
'--------------------------------------------------------------------------


'--------------------------
'------ I/O PORTS ---------
'--------------------------

define LED       port[5]
define BEEPER    port[6]
define ADC1      ad[1]
define ADC2      ad[2]
define ADC5      ad[5]
define ADC6      ad[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define OSCTRIM   byte[1]
define DAUER     byte[2]

'--------------------------------------------------
'-----------  SHOWING FREQUENCY RANGE    ----------
'--------------------------------------------------

#START

BEEPER=off
'goto LOOP2

'------ DEMO1 ----------------
#LOOP
for DAUER =1 to 10
TOG BEEPER
next
OSCTRIM=OSCTRIM+1:FREQ2=OSCTRIM
goto LOOP
'----- DEMO2------------------
#LOOP2
For OSCTRIM=0 to 255
FREQ2=OSCTRIM:TOG BEEPER
NEXT
pause 10:goto LOOP2





